package com.cisco.ccl.b2b.kc.model;

import org.json.simple.JSONObject;

public class DocumentsBuilder {
    Documents documents = new Documents();
    private Document currentDocument;


    public DocumentsBuilder addDocument(String documentId, String uri) {
        currentDocument = new Document(documentId, uri);
        documents.add(currentDocument);
        return this;
    }

    public DocumentsBuilder withMetadata(String key, String value) {
        JSONObject metadata = currentDocument.getMetadata() == null ? new JSONObject() : currentDocument.getMetadata();
        metadata.put(key, value);
        currentDocument.setMetadata(metadata);
        return this;
    }

    public Documents build() {
        return documents;
    }
}
