package com.cisco.ccl.b2b.kc.service;

import com.cisco.ccl.b2b.kc.model.Documents;
import com.cisco.ccl.b2b.kc.model.DocumentsBuilder;
import org.junit.Before;
import org.junit.Test;
import org.mockito.Mock;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.client.RestTemplate;

import static name.mlnkrishnan.shouldJ.ShouldJ.it;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;
import static org.mockito.MockitoAnnotations.initMocks;

public class DocumentServiceTest {

    private DocumentService documentService;

    @Mock
    private RestTemplate restTemplate;
    private String baseUrl;

    @Before
    public void setUp() {
        initMocks(this);
        baseUrl = "http://localhost:8003/contentstore";

        documentService = new DocumentService(restTemplate, baseUrl);
    }

    @Test
    public void shouldLoadAllDocuments() {
        String contentStoreURL = baseUrl + "/documents";
        Documents documents = new DocumentsBuilder()
                .addDocument("123456", "ftp://localhost/123456")
                .withMetadata("k1", "v1")
                .addDocument("123457", "ftp://localhost/123457")
                .build();


        ResponseEntity<Documents> response = new ResponseEntity<Documents>(documents, HttpStatus.OK);
        when(restTemplate.getForEntity(contentStoreURL, Documents.class)).thenReturn(response);

        Documents actualDocuments = documentService.loadAllDocuments();

        it(actualDocuments).shouldBeOfSize(2);
        verify(restTemplate).getForEntity(contentStoreURL, Documents.class);
    }
}
