package fakerest;

import fakerest.request.Route;
import fakerest.request.RouteRegister;
import fakerest.request.HttpMethod;

public class FakeRest {
	
	private static final FakeRestServer server = new FakeRestServer();

	public static FakeRestResponse whenGet(String uri) {
		return registerRoute(HttpMethod.GET, uri);
	}

	public static FakeRestResponse whenPost(String uri) {
		return registerRoute(HttpMethod.POST, uri);
	}
	
	private static FakeRestResponse registerRoute(HttpMethod method, String uri) {
		return new RouteRegister(new Route(method, uri));
	}

	public static void startServer() {
		startServer(8080);
	}

	public static void startServer(int port) {
		server.start(port);
	}

	public static void stopServer() {
		server.stop();
	}

}
