package fakerest.request;

import fakerest.FakeRestResponse;
import fakerest.response.Response;
import fakerest.response.JSON;
import fakerest.response.TextPlain;


public class RouteRegister implements FakeRestResponse {

	private final Route route;

	public RouteRegister(Route route) {
		this.route = route;
	}



	@Override
	public void thenReturnText(String value) {
		registerRoute(new TextPlain(value));
	}
	
	@Override
	public void thenReturnJSON(String value) {
		registerRoute(new JSON(value));
	}
	
	@Override
	public void thenReturnJSON(Object object) {
		try {
			registerRoute(new JSON(object));
		} catch (Exception exception) {
			throw new RuntimeException(exception);
		}
	}
	
	@Override
	public void thenReturnErrorCodeWithMessage(int errorCode, String message) {
		Response response = new TextPlain(message);
		response.setResponseStatus(errorCode);
		
		registerRoute(response);
	}
	
	private void registerRoute(Response body) {
		RouteManager.getInstance().registerRoute(route, body);
	}
	
}
