package fakerest;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import fakerest.request.HttpMethod;
import fakerest.request.Route;
import fakerest.request.RouteManager;
import fakerest.request.RouteRegister;
import fakerest.response.ContentType;
import fakerest.response.Response;

public class HttpResponseForPOSTMethodTest {
	
	private RouteRegister subject;
	private Route route;
	
	@Before
	public void setUp() {
		route = new Route(HttpMethod.POST, "/teste/");
		subject = new RouteRegister(route);
	}
	
	@Test
	public void testSimpleTextResponse() {
		subject.thenReturnText("Test succeed");
		
		Response response = RouteManager.getInstance().get(route);
		
		Assert.assertEquals(ContentType.TEXT_PLAIN, response.getContentType());
		Assert.assertEquals("Test succeed", response.getContent());
	}

}
